#!/usr/bin/python
# 3D MRI - Converts a series of slices into a 3D grid of voxels.
# Render a series of slices on other axies.
# Copyright (C) November 2007 Neil Fraser
# http://neil.fraser.name/

# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General
# Public License as published by the Free Software Foundation.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# http://www.gnu.org/

import sys
import os
import file_lib

# How many pixels to crop off each side.
croptop = 0
cropbottom = 0
cropfront = 0
cropback = 0
cropright = 11
cropleft = 9

if len(sys.argv) != 2:
  print "Usage: %s <source datafile>" % sys.argv[0]
  sys.exit()

datapath = sys.argv[1]
a = file_lib.load_data("", datapath)
(x, y, z) = file_lib.get_xyz(a)

if cropbottom == 0:
  cropbottom = y
else:
  cropbottom *= -1
if cropback == 0:
  cropback = x
else:
  cropback *= -1
if cropleft == 0:
  cropleft = z
else:
  cropleft *= -1

print "Cropping data (%d x %d x %d)" % (x, y, z)

# Crop off left and right.
a = a[cropright:cropleft]
for k in xrange(len(a)):
  # Crop off top and bottom.
  a[k] = a[k][croptop:cropbottom]
  for j in xrange(len(a[0])):
    # Crop off front and back.
    a[k][j] = a[k][j][cropfront:cropback]

(x, y, z) = file_lib.get_xyz(a)
print "Data cropped (%d x %d x %d)\n" % (x, y, z)

file_lib.save_data("", datapath, a)
