#!/usr/bin/python
# 3D MRI - Converts a series of slices into a 3D grid of voxels.
# Render a series of slices on other axies.
# Copyright (C) November 2007 Neil Fraser
# http://neil.fraser.name/

# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General
# Public License as published by the Free Software Foundation.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# http://www.gnu.org/

import sys
import os
import file_lib

if len(sys.argv) != 2:
  print "Usage: %s <source datafile>" % sys.argv[0]
  sys.exit()

datapath = sys.argv[1]
a = file_lib.load_data("", datapath)
(x, y, z) = file_lib.get_xyz(a)

bins = []
for b in xrange(256):
  bins.append(0)

print "Scanning data (%d x %d x %d) into %d bins" % (x, y, z, len(bins))
for k in xrange(z):
  sys.stdout.write(".")
  sys.stdout.flush()
  for j in xrange(y):
    for i in xrange(x):
      pixel = int(a[k][j][i] * (len(bins) - 1) + 0.5)
      bins[pixel] += 1
print "Done.\n"

for b in xrange(len(bins)):
  print "%d, %d" % (b, bins[b])
