#!/usr/bin/python
# Shared file access functions.

import sys
import os

def get_xyz(data):
  z = len(data)
  y = len(data[0])
  x = len(data[0][0])
  return (x, y, z)

def save_data(dir, filename, data):
  #if not os.path.exists(dir):
  #  print "Directory not found: %s" % dir
  #  sys.exit()
  filepath = os.path.join(dir, filename)

  (x, y, z) = get_xyz(data)

  print "Exporting data to %s" % filepath
  f = open(filepath, "w")
  f.write("%d\n" % x)
  f.write("%d\n" % y)
  f.write("%d\n" % z)
  for k in xrange(z):
    sys.stdout.write(".")
    sys.stdout.flush()
    for j in xrange(y):
      for i in xrange(x):
        f.write("%f," % data[k][j][i])
  f.write("\n")
  f.close()
  print "Done.\n"

def load_data(dir, filename):
  filepath = os.path.join(dir, filename)
  if not os.path.isfile(filepath):
    print "File not found: %s" % filepath
    sys.exit()

  print "Importing data from %s" % filepath
  f = open(filepath, "r")
  # First three lines are x, y and z respectively.
  x = int(f.readline())
  y = int(f.readline())
  z = int(f.readline())
  # Fourth line is all the pictures' pixels.
  allpixels = f.read().split(',')
  images = []
  n = 0
  for k in xrange(z):
    sys.stdout.write(".")
    sys.stdout.flush()
    image = []
    for j in xrange(y):
      row = []
      for i in xrange(x):
        try:
          row.append(float(allpixels[n]))
        except ValueError:
          print "\nValueError at %d\n" % n
        n += 1
      image.append(row)
    images.append(image)
  print "Done.\n"
  return images
